#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include "checkproc.h"

void print_noproc_message(const char *filename) {
    perror(filename);
    if (errno == ENOENT)
        fputs(
"Error: /proc must be mounted\n"
"  To mount /proc at boot you need an /etc/fstab line like:\n"
"      proc   /proc   proc    defaults\n"
"  In the meantime, run \"mount proc /proc -t proc\"\n",
            stderr);
    fflush(NULL);
}

int checkproc(int rc) {
    if (access("/proc/self/stat", R_OK) == 0)
        return 0;
    print_noproc_message("/proc/self/stat");
    if (rc)
        exit(rc);
    return -1;
}
